using System.Linq;
using Foundation;
using Telerik.XamarinForms.Common.iOS;
using Telerik.XamarinForms.DataControlsRenderer.iOS.ListView;
using TelerikUI;

namespace SampleApp.iOS
{
    public class CustomDelegate : ListViewDelegate
    {
        private readonly CustomListView listView;

        public CustomDelegate(CustomListView customListView)
        {
            this.listView = customListView;
        }

        public override void DidLongPressCell(TKListView listView, TKListViewCell cell, NSIndexPath indexPath)
        {
            var item = GetItemAtPath(listView.WeakDataSource as TKDataSource, indexPath).ToObject();
            this.listView.RaiseLongPress(item);
        }

        private static NSObject GetItemAtPath(TKDataSource source, NSIndexPath indexPath)
        {
            if (source.GroupDescriptors().Count() == 0)
            {
                return source.Items[indexPath.Row];
            }
            else
            {
                return((TKDataSourceGroup)source.Items[indexPath.Section]).Items[indexPath.Row];
            }
        }
    }
}